/*
 * File         : SOCK_Acceptor.h
 * Author       : Tomasz Stachowiak
 * Created      : Tue May 19 18:54:36 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#ifndef __SOCK_ACCEPTOR_H
#define __SOCK_ACCEPTOR_H

#include <BVN/SAP.h>
#include <BVN/BVN.h>
#include <BVN/SOCK_Stream.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

class SOCK_Acceptor
{

 public:

  typedef struct sockaddr_in PEER_ADDR;
  typedef struct SOCK_Stream PEER_STREAM;

  int open(PEER_ADDR *addr);
  int accept(PEER_STREAM *stream);
  HANDLE get_handle(void);
  int close(void);

 private:

  SAP sap;
};


#endif

